//
//  Counter.m
//  A simple program to count the number of lines, words, and chars in a file
//
//  Created by Rene Hexel on 25/10/06.
//  Copyright 2006, 2008 Rene Hexel. All rights reserved.
//

#include <stdio.h>
#include <sstream>
#include <fstream>
#include "Counter.h"

using namespace std;

/**
 * Constructor to count the words in a given text string
 */
Counter::Counter(string &text)
{
	content = text;				// use the text for counting
}


/**
 * Constructor to count the words in a given file
 */
Counter::Counter(char *fileName)		// count word in given file
{
	ifstream file(fileName);		// open file for input 
	string line;				// a single line of input

	content = "";				// clear the content

	// read the content of the file
	while (getline(file, line))
	{
		content.append(line);		// add the line to the string
		content.append("\n");		// add a newline
	}
}


/**
 * do the actual counting of lines, words, and characters
 */
void Counter::count()				// do the actual counting
{
	nChars = content.length();		// length in characters

	istringstream reader(content);		// string stream for content
	
	string line;				// one line of text
	while (getline(reader, line))
	{
		nLines++;
		
		istringstream lineScanner(line);
		string word;

		while (lineScanner >> word)
			nWords++;
	}
}


/**
 * return the number of lines counted
 */
int Counter::lines()
{
	return nLines;
}


/**
 * return the number of words counted
 */
int Counter::words()
{
	return nWords;
}

/**
 * return the number of characters counted
 */
int Counter::characters()
{
	return nChars;
}
